<?php 
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Database Cleanup"		                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0 / November 2009

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

require(CPO_BASEDIR.'_include/check.php');
require(CPO_BASEDIR.'_include/header.php');

//echo '<pre>';
//print_r($_POST);
//echo '</pre>';

if ($_POST['reset'])  unset ($_POST);

//echo '<pre>';
//print_r($_POST);
//echo '</pre>';

$q_cal_time = date('Y-m-d H:i:s',time()-$_POST['deltime']);
$q_time = ($_POST['deltime']) ? " AND last_modify<='".$q_cal_time."'" : '';
$q_rubric = ($_POST['rubricdel']) ? " AND rubric_id='".$_POST['rubricdel']."'" : '';
$q_autor = ($_POST['autor']) ? " AND autor='".$_POST['autor']."'" : '';
$q_changer = ($_POST['changer']) ? " AND changer='".$_POST['changer']."'" : '';
$q_all = $q_time.$q_rubric.$q_autor.$q_changer ;

$query_keep = "SELECT nr, article_nr FROM ".CPO_NEWS." WHERE artikel_archiv=5 ORDER BY nr DESC";
$db_keep = new DB;
$db_keep->query($query_keep);
while($db_keep->next_record())  {
	if (count($keep_array[$db_keep->v('article_nr')]) >= $_POST['keepversions']) continue;
	$keep_array[$db_keep->v('article_nr')][] = $db_keep->v('nr');
	if (is_array($keep_array[$db_keep->v('article_nr')])) $keep_nrs[$db_keep->v('article_nr')] = implode(", ",$keep_array[$db_keep->v('article_nr')]);
}
//foreach($keep_array AS $keep_array_subarray)
$keep_instring = ($_POST['keepversions'] && is_array($keep_nrs)) ? implode(", ",$keep_nrs) : '0' ;
$q_keep = ($_POST['keepversions']) ? " AND nr NOT IN (".$keep_instring.") " : '';
$q_keep = $q_keep.$q_all;


// die verfgbaren Lschoptionen (die Kommas nicht aus Versehen lschen) **************************

//	'name' => array (										<= Der Name der Aktion
//		'angezeigter Text',									<= Der im Formular angzeigte Text
//		"artikel_archiv = 9",								<= die WHERE-Bedingung fr die zu lschenden Artikel
//		" gelschte Artikel wurden endgltig gelscht!",	<= Die Meldung (Anzahl wird vorangestellt)
//		'deleted articles finally deleted',					<= Der Eintrag im Logfile
//		true												<= ist die Aktion vorausgewhlt? true/false
//		),													<= nur bei der letzten Aktion kein! Komma
// and die WERE-Bedingung kann .$q_all angehngt werden, wenn die whlbaren Einschrnkungen benutzt werden sollen,
// bzw. .$q_keep fr das Erhalten der letzten x Artikel-Versionen inkl. der Einschrnkungen

// AKTIONEN ***************************************************************************************
$del_array = array(
	'delete' => array (
		'Gelschte Artikel endgltig lschen',
		"artikel_archiv = 9".$q_all,
		" gelschte Artikel wurden endgltig gelscht!",
		'deleted articles finally deleted',
		true
		),
	'versions' => array (
		'Alte Artikelversionen lschen',
		"artikel_archiv = 5".$q_keep,
		" alte Artikelversionen wurden endgltig gelscht!",
		'old article versions deleted',
		false
		),
	'expired' => array (
		'Verfallene Artikel lschen (<b>Achtung:</b> Hiermit wird das Archiv gelscht!)',
		"verfallsdatum < '".date('Y-m-d H:i:s', time())."'".$q_all,
		" verfallene Artikel wurden endgltig gelscht!",
		'expired versions deleted',
		false
		),
	'blocked' => array (
		'Gesperrte Artikel lschen',
		"freigabe = ".STATE_BLOCKED.$q_all,
		" gesperrte Artikel wurden endgltig gelscht!",
		'blocked versions deleted',
		false
		),
	'rejected' => array (
		'Abgewiesene Artikel lschen',
		"freigabe = ".STATE_REJECTED.$q_all,
		" abgewiesene Artikel wurden endgltig gelscht!",
		'rejected versions deleted',
		false
		)
	);
$optimize_checked = true;
// AKTIONEN ***************************************************************************************


// EINSCHRNKUNGEN ***************************************************************************************
	// Zeitliche Einschrnkung *******************************************************************************
	$d2s = 24*60*60;
	$time_array = array(
		'[keine]'			=> 0,
		'lter als 1 Tag'	=> $d2s,
		'lter als 2 Tage'	=> 2*$d2s,
		'lter als 3 Tage'	=> 3*$d2s,
		'lter als 1 Woche'	=> 7*$d2s,
		'lter als 2 Wochen'=> 14*$d2s,
		'lter als 1 Monat'	=> 31*$d2s,
		'lter als 3 Monate'=> 92*$d2s,
		'lter als 1 Jahr'	=> 365*$d2s
		);
	$time_select = '<select name="deltime">';
	foreach ($time_array AS $del_text=>$del_time) {
		$time_select .= '<option value="'.$del_time.'"'.($_POST['deltime']==$del_time ? ' selected="selected"' : '').'>'.$del_text.'</option>';
	}
	$time_select .= '</select>';

	// Versions Einschrnkung *******************************************************************************
	$version_array = array(
		'[keine]'					=> 0,
		'1 alte Version behalten'	=> 1,
		'2 alte Versionen behalten'	=> 2,
		'5 alte Versionen behalten'	=> 5,
		'10 alte Versionen behalten'=> 10
		);
	$version_select = '<select name="keepversions">';
	foreach ($version_array AS $ver_text=>$ver_val) {
		$version_select .= '<option value="'.$ver_val.'"'.($_POST['keepversions']==$ver_val ? ' selected="selected"' : '').'>'.$ver_text.'</option>';
	}
	$version_select .= '</select>';

	// User Einschrnkung *******************************************************************************
	$query = 'SELECT user, name '
			.'FROM '.CPO_USER.' '
			."ORDER BY user ";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
	$user_array = array();
	while ($db->next_record()) {
		$user_array[$db->v('user')] = $db->v('name');
	}

	$autor_select = '<select name="autor">';
	$autor_select .= '<option value="0">'.__('[none]').'</option>';
	foreach ($user_array AS $user=>$name) {
		$usertext = ($name==$user) ? $name : $name.' ('.$user.')';
		$autor_select .= '<option value="'.$name.'"'.($_POST['autor']==$name ? ' selected="selected"' : '').'>'.$usertext.'</option>';
	}
	$autor_select .= '</select>';

	$changer_select = '<select name="changer">';
	$changer_select .= '<option value="0">'.__('[none]').'</option>';
	foreach ($user_array AS $user=>$name) {
		$usertext = ($name==$user) ? $name : $name.' ('.$user.')';
		$changer_select .= '<option value="'.$user.'"'.($_POST['changer']==$user ? ' selected="selected"' : '').'>'.$usertext.'</option>';
	}
	$changer_select .= '</select>';

	// Rubrikeinschrnkung ***********************************************************************************************
	$rubric_select = '<select name="rubricdel">';
	$rubric_select .= '<option value="0">'.__('[none]').'</option>';

	if (!empty($_SESSION['SID_user']['id'])) {

		// fetch all rubrics this user has access to
		$query = 'SELECT rubric_id '
				.'FROM '.CPO_PERMISSION.' '
				."WHERE user_id='".addslashes($_SESSION['SID_user']['id'])."' ";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query);
		$rubricAccess = array();
		while ($db->next_record()) {
			$rubricAccess[$db->v('rubric_id')] = true;
		}

		// fetch all rubrics to show the ones not in navigation
		$query = 'SELECT id, name, seclevel '
				.'FROM '.CPO_RUBRIC.' '
				.'ORDER BY name';
		DEBUG(1, $query, __FILE__, __LINE__);
		$db->query($query);
		$notInNavigation = array();
		while ($db->next_record()) {
			$notInNavigation[$db->v('id')] = array(
				'id'=>0,
				'l'=>0,
				'r'=>0,
				'level'=>1,
				'childs'=>0,
				'caption'=>'',
				'navigation'=>array(),
				'rubric'=>array('id'=>$db->v('id'), 'name'=>$db->v('name'), 'seclevel'=>$db->v('seclevel'), )
			);
		}

		$navigation = getNavigation();
		foreach ($navigation as $k=>$v) {

			$path[$v['level']] = $v['caption'];

			if (array_key_exists($v['rubric']['id'], $notInNavigation)) unset($notInNavigation[$v['rubric']['id']]);

			if ($v['rubric']['id']<=0) continue;
			if (!array_key_exists($v['rubric']['id'], $rubricAccess)) continue;

			$entry = implode('/', array_slice($path, 0, $v['level']));
			if ($v['caption']!=$v['rubric']['name']) $entry .= ' ('.$v['rubric']['name'].')';
			if (strlen($entry)>90) $entry = '...'.substr($entry, -87);

			$rubric_select .= sprintf('<option value="%d" %s>%s</option>',
				$v['rubric']['id'],
				($v['rubric']['id']==$_POST['rubricdel']) ? ' selected="selected"' : '',
				$entry
			);
		}

		$_t = '<option value=""> </option>';
		foreach ($notInNavigation as $k=>$v) {
			if (!array_key_exists($v['rubric']['id'], $rubricAccess)) continue;
			$rubric_select .= $_t;
			$_t = '';

			$path[$v['level']] = $v['rubric']['name'];

			$entry = implode('/', array_slice($path, 0, $v['level']));
			// no navigational element i
			// if ($v['caption']!=$v['rubric']['name']) $entry .= ' ('.$v['rubric']['name'].')';
			if (strlen($entry)>90) $entry = '...'.substr($entry, -87);

			$rubric_select .= sprintf('<option value="%d" %s>%s</option>',
				$v['rubric']['id'],
				($v['rubric']['id']==$_POST['rubricdel']) ? ' selected="selected"' : '',
				$entry
			);
		}
	}
	$rubric_select .= '</select>';
// EINSCHRNKUNGEN ***************************************************************************************


// es gibt was zu tun...
if ($_POST['del'])  {
	$db_versions = new DB;
	$db_delete = new DB;

	if (is_array($_POST['del_action']))  {
		foreach ($_POST['del_action'] AS $req_action=>$req_val)  {
			$where = $del_array[$req_action][1];
			$query_versions = "SELECT nr FROM ".CPO_NEWS." WHERE ".$where;
			$db_versions->query($query_versions);
			while($db_versions->next_record())  {
				$query_delete = "DELETE FROM ".CPO_CONTENT_FILES." WHERE article_id = ".$db_versions->v('nr');
				$db_delete->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_HTML." WHERE article_id = ".$db_versions->v('nr');
				$db_delete->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_IMAGES." WHERE article_id = ".$db_versions->v('nr');
				$db_delete->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_TEXT." WHERE article_id = ".$db_versions->v('nr');
				$db_delete->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_URLS." WHERE article_id = ".$db_versions->v('nr');
				$db_delete->query($query_delete);
			}
			$query_delete = "DELETE FROM ".CPO_NEWS." WHERE ".$where;
			$db_delete->query($query_delete);
			$message[] = $db_delete->affected_rows().$del_array[$req_action][2]; 
			logaction($del_array[$req_action][3], '');
		}
	}

	if ($_POST['optimize'] == true)  {
		//Optimieren
		$tables = '';
		$divider = '';
		$db = new DB;
		$query_optimize = "SHOW TABLES";
		$db->query($query_optimize);
		while($db->next_record())  {
			$tables .= $divider.$db->v('Tables_in_'.$db->Database);
			$divider = ', ';
		}
		$query_optimize = "OPTIMIZE TABLE ".$tables;
		if ($db->query($query_optimize)) $message[] = "Datenbank erfolgreich optimiert!"; 
		logaction('tables optimized', '');
	}

}

// Die Formularseite

printPageHeader(
    __('Datenbank Wartung'),
    __('In dieser Ansicht knnen Sie die Datenbank optimieren.<br /><br /><b>Hinweis:</b> Die angezeigte Anzahl zeigt die Zahl der den Kriterien entsprechenden Artikel. Da ein Artikel mehrere Kriterien erfllen kann (z.B. ein verfallener Artikel, der gelscht wurde), kann sich die berechnete Anzahl auch dann ndern, wenn das Kriterium nicht explizit ausgewhlt wurde.')
);

include(CPO_BASEDIR.'_include/message.php');
?>

<form action="database_cleanup.php" method="post">
    <table class="colored" style="width: 100%"><thead>
        <tr>
            <th colspan="2"><span>Datenbankaktionen</span></th>
        </tr>
    </thead><tbody>
		<tr>
			<td >
				<b>Einschrnkungen:</b>
				<table cellpadding="0" cellspacing="0">
				<tr>
					<td>Zeitraum: </td>
					<td><?php echo $time_select; ?></td>
				</tr>
				<tr>
					<td>Rubrik: </td>
					<td><?php echo $rubric_select; ?></td>
				</tr>
				<tr>
					<td>Autor: </td>
					<td><?php echo $autor_select; ?></td>
				</tr>
				<tr>
					<td>Letzter Bearbeiter: </td>
					<td><?php echo $changer_select; ?></td>
				</tr>
				<tr>
					<td>Versionen behalten: </td>
					<td><?php echo $version_select; ?></td>
				</tr>
				<tr>
					<td></td>
					<td><input type="submit" name="cal" value="Neuberechnen" /> <input type="submit" name="reset" value="Zurcksetzen" /></td>
				</tr>
				</table>
			</td>
        </tr>
<?php
	$db_versions = new DB;
	foreach ($del_array AS $del_action=>$del_vars) {
		$checked = ($del_vars[4]) ? ' checked="checked"' : '';
		$where = $del_vars[1];
		$query_versions = "SELECT nr FROM ".CPO_NEWS." WHERE ".$where;
		$db_versions->query($query_versions);
		$anzahl = $db_versions->num_rows();
?>
		<tr>
			<td ><input type="checkbox" name="del_action[<?php echo $del_action; ?>]" value="true"<?php echo $checked; ?> /> <?php echo $del_vars[0]; ?> (Anzahl: <?php echo $anzahl; ?>)<!-- <br /><?php echo $where; ?> --></td>
        </tr>
<?php
	}
	$checked = ($optimize_checked) ? ' checked="checked"' : '';
?>
		<tr>
            <td class="leftrow"><input type="checkbox" name="optimize" value="true"<?php echo $checked; ?> /> Datenbank optimieren</td>
        </tr>
        <tr>
            <td><input type="submit" name="del" value="Ausfhren" /></td>
        </tr>
    </tbody></table>
</form>

<?php
	require(CPO_BASEDIR.'_include/footer.php');
?>
